package com.nisum.offertransactionservice.config;

import feign.Retryer;
import feign.codec.ErrorDecoder;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class FeignClientConfig {

    @Value("#{new Integer('${maxattempts}')}")
    private Integer maxAttempts;

    @Value("#{new Long('${backoff}')}")
    private Long backoff;

    @Bean
    public Retryer retryer() {
        return new CustomRetryer(backoff,maxAttempts);
    }

    @Bean
    public ErrorDecoder errorDecoder() {
        return new CustomErrorDecoder();
    }
}