package com.nisum.offertransactionservice.handler;

import com.nisum.offertransactionservice.service.CustomCreatedCustomException;
import org.json.JSONObject;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestControllerAdvice;

import javax.servlet.http.HttpServletResponse;
import java.util.Map;

@RestControllerAdvice
public class FeignExceptionHandler {

    @ExceptionHandler({CustomCreatedCustomException.class})
    public Map<String, Object> handleFeignStatusException(CustomCreatedCustomException e, HttpServletResponse response) {
        response.setStatus(e.getStatus());
        return new JSONObject(e.getContentUTF8()).toMap();
    }
}
