package com.nisum.offertransactionservice.service;

import com.nisum.offertransactionservice.client.StoreProducerFeignClient;
import com.nisum.offertransactionservice.genericexception.GlobalApiGenericException;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.NullSource;
import org.junit.jupiter.params.provider.ValueSource;
import org.mockito.ArgumentMatchers;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import reactor.core.publisher.Mono;

import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.Mockito.when;

public class EndOfTransactionTest {

    @InjectMocks
    private EndOfTransactionService endOfTransactionService;

    @Mock
    @Autowired
    private StoreProducerFeignClient storeProducerFeignClient;

    @BeforeEach
    public void setUp() throws Exception {
        MockitoAnnotations.initMocks(this);
    }


    @DisplayName("This test will  test the  endOfTransactionTest method ")
    @ParameterizedTest
    @ValueSource(strings={"86fd4146-0540-405b-b621-a95f4ccdfa0d"})
    public void endOfTransactionTest(String uuid) {
        ResponseEntity<String> responseEntity = ResponseEntity.ok("test");
        when(storeProducerFeignClient.callStoreProducer(ArgumentMatchers.any())).thenReturn(responseEntity);
        String storeResponse = endOfTransactionService.endOfTransaction(uuid);
        assertNotNull(storeResponse);
        assertEquals("test",storeResponse);
    }


    @DisplayName("This test will  test the  endOfTransactionTest method ")
    @ParameterizedTest
    @NullSource
    public void endOfTransactionNegTest(String uuid) {

        assertThrows(GlobalApiGenericException.class, () -> {
            endOfTransactionService.endOfTransaction(uuid);
        });
    }
}
